<template>
  <div
    ref="webGL"
    class="earth"
  />
</template>

<script>
import THREE from "three";
import TrackballControls from "three-trackballcontrols";
import _ from "lodash";

// Earth params
var radius = 0.5,
  segments = 32,
  rotation = 6;

function createSphere(radius, segments) {
  return new THREE.Mesh(
    new THREE.SphereGeometry(radius, segments, segments),
    new THREE.MeshPhongMaterial({
      map: new THREE.TextureLoader().load("/earth/2_no_clouds_4k.jpg"),
      bumpMap: new THREE.TextureLoader().load("/earth/elev_bump_4k.jpg"),
      bumpScale: 0.005,
      specularMap: new THREE.TextureLoader().load("/earth/water_4k.png"),
      shininess: 10,
      specular: new THREE.Color("grey")
    })
  );
}

function createClouds(radius, segments) {
  return new THREE.Mesh(
    new THREE.SphereGeometry(radius + 0.003, segments, segments),
    new THREE.MeshPhongMaterial({
      map: new THREE.TextureLoader().load("/earth/fair_clouds_4k.png"),
      transparent: true
    })
  );
}

function createStars(radius, segments) {
  return new THREE.Mesh(
    new THREE.SphereGeometry(radius, segments, segments),
    new THREE.MeshBasicMaterial({
      map: new THREE.TextureLoader().load("/earth/galaxy_starfield.png"),
      side: THREE.BackSide
    })
  );
}

var destructionId = undefined;
var controls;
var renderer;
var camera;
var debouncedResize;

export default {
  name: "Earth",
  mounted: function() {
    var webGLel = this.$refs.webGL;

    // resize is debounced so that it doesn't run every single tick, but
    // once every 50 milliseconds. Improves performance.
    debouncedResize = _.debounce(this.onResize, 50);
    window.addEventListener('resize', debouncedResize);

    this.$nextTick(function() {

      var width = webGLel.offsetWidth;
      var height = webGLel.offsetHeight;

      // Earth parameters
      var scene = new THREE.Scene();

      camera = new THREE.PerspectiveCamera(90, width / height, 0.01, 1000);
      camera.position.z = 1.5;

      renderer = new THREE.WebGLRenderer();
      renderer.setPixelRatio(1);
      renderer.setSize(width, height);

      scene.add(new THREE.AmbientLight(0x333333));

      var light = new THREE.DirectionalLight(0xffffff, 1);
      light.position.set(5, 3, 5);
      scene.add(light);

      var sphere = createSphere(radius, segments);
      sphere.rotation.y = rotation;
      scene.add(sphere);

      var clouds = createClouds(radius, segments);
      clouds.rotation.y = rotation;
      scene.add(clouds);

      var stars = createStars(90, 64);
      scene.add(stars);

      controls = new TrackballControls(camera, webGLel);

      webGLel.appendChild(renderer.domElement);

      render();

      function render() {
        controls.update();
        sphere.rotation.y += 0.0005;
        clouds.rotation.y += 0.0005;
        destructionId = requestAnimationFrame(render);
        renderer.render(scene, camera);
      }
    });
  },
  beforeDestroy: function() {
    cancelAnimationFrame(destructionId);

    window.removeEventListener('resize', debouncedResize);
  },
  methods: {
    // Reset the 3D view
    reset: function() {
      controls.reset();
    },
    setQuality: function(quality) {
      renderer.setPixelRatio(quality);
    },
    onResize: function() {
      var webGLel = this.$refs.webGL;
      var width = webGLel.offsetWidth;
      var height = webGLel.offsetHeight;
      renderer.setSize(width, height);
      camera.aspect = width / height;
      camera.updateProjectionMatrix();
    }
  }
};
</script>

<style lang="scss">
.earth {
  width: 100%;
  height: 100%;
  background-color: black;
}
</style>
